format longG
close all; clear; clc; clf;

%%Axels
AxelSpacing=[ 2.500 14.000 2.500 5.125 2.550 13.975 2.500 ];%Axel Spacing (m)
AxWeights=[ 83 83 83 83 142 142 142 142 ];

%%Bridge
L=30;                                                 %Lenght of bridge (m)
%%speed
v=20;                                                    %train speed (m/s)
%%Sensors
S=2;                                                   %Sensor Distance (m)
mps=1024;                                     %measurements per second (Hz)

%%InfluenceLine
I = load('IL20.txt');
I = ([I(:,9), I(:,2), I(:,3)]);

% AxelSpacing = flip(AxelSpacing);
% AxWeights = flip(AxWeights);
% I = flip(I);

%%Use this to change the mps
% x1 = 1:length(I);
% x2 = 1:2:1537;
% I = interp1(x1,I,x2);

%%InfluenceOrdinatesMatrix
lengthM = 5000;
M = influenceOrdinatesMatrix(I, v, mps, lengthM, AxelSpacing, 700);

%%Strains
strain = zeros(size(M,1),size(M,4));
    for i=1:size(I,2)
        strain(:,i) = M(:,:,1,i)*transpose(AxWeights);
        strain(:,i)=awgn(strain(:,i), 22, 'measured');
        strain(:,i)=strain(:,i)+transpose(sin(2*pi*10*(1:lengthM)))*5e-7;
    end

x = 1:size(M,1);
figure(1);
plot(x,strain);
set(gcf, 'position',[676 361 780 440]);
% title('Simulert Tog');
legend('Midt','Mot Trondheim','Mot Heimdal');
xlim([0 size(M,1)]);
% ylim([1.15e-5 1.6e-5]);
xlabel('Tid (1024 per sekund)')
ylabel('{\sigma}','rotation',0)

%%Filter
cutoff = 50;
axelSlice = 20;
scale = 1:50;

[strainFilteteredButter] = filterStrain(strain, mps, cutoff);

figure();
plot(x,strain(:,1),x,strainFilteteredButter(:,1),'r');
set(gcf, 'position',[676 361 780 440]);
% title('Butterfilter');
legend('Strain','Filtrert');
% xlim([950 1250]);
% ylim([1.15e-5 1.6e-5]);
xlabel('Tid (1024 per sekund)')
ylabel('{\sigma}','rotation',0)

[strainFilteteredWaveAxel, waveletSurface] = wavelet(strain,scale,axelSlice);

figure();
surf(waveletSurface(:,:,1,1));
% title('Wavelet');
set(surf(waveletSurface(:,:,1,1)),'LineStyle','none');
axis([0 size(waveletSurface,2) scale(1) scale(end)]);
xlabel('Tid (1024 per sekund')
ylabel('Skala')
zlabel('Wavelet koeffisient')

figure();
plot(strainFilteteredWaveAxel);
set(gcf, 'position',[676 361 780 440]);
xlim([0 size(M,1)]);
title(['Strain Filtered by Wavelet for slice ' num2str(axelSlice)]);

%%Speed
[vcor] = speed2(strainFilteteredButter, 2, 3, mps, S);

%%Axel Spacing
axelSpacingTrue = axelSpacing(strainFilteteredWaveAxel, 1, mps, v);

axelDifference=round((axelSpacingTrue-AxelSpacing)*1000);
axelDifferenceTotalt = sum(axelDifference);
axelDifferencePercent = round(axelSpacingTrue./AxelSpacing*100-100)
axelDifferenceClosestonall = sum(abs(axelDifference));

axeltable = round([ transpose(AxelSpacing), transpose(axelSpacingTrue) ],2)

%%Weights
M = influenceOrdinatesMatrix(I, v, mps, lengthM, axelSpacingTrue, 00);
A=(inv(transpose(M(:,:,1,1))*M(:,:,1,1)))*(transpose(M(:,:,1,1))*strain(:,1));
A=transpose(A);
axelWeightPercent = round(A./AxWeights*100-100)
totalWeightPercent = sum(A)/sum(AxWeights)*100