format longG
close all; clear; clc; clf;

%%Axels
axelSpacing1 = [ 2.500 14.000 2.500 5.125 2.550 13.975 2.500 ];%Axel Spacing (m)
axWeights = [ 83 83 83 83 142 142 142 142 ];

%%Bridge
L=30;                                                 %Lenght of bridge (m)
%%speed
v=20;                                                    %train speed (m/s)
%%Sensors
S=1;                                                   %Sensor Distance (m)
mps=1024;                                     %measurements per second (Hz)

%%InfluenceLine
I = load('IL20.txt');
I = [I(:,9)]*6;

axelSpacing1 = flip(axelSpacing1);
axWeights = flip(axWeights);
I = flip(I);

%%InfluenceOrdinatesMatrix
lengthM = 5000;
M = influenceOrdinatesMatrix(I, v, mps, lengthM, axelSpacing1, 800);

teller=0;
for k=1:10000
teller=1+teller
%%Strains
strain = zeros(size(M,1),size(M,4));
    for i=1:size(I,2)
        strain(:,i) = M(:,:,1,i)*transpose(axWeights);
%         strain(:,i) = strain(:,i)+2*(rand(size(strain(:,i)))-0.5)*5e-7;
        strain(:,i)=awgn(strain(:,i), 22, 'measured');
        strain(:,i)=strain(:,i)+transpose(sin(2*pi*10*(1:lengthM)))*5e-7;

    end

% figure(1);
% plot(strain);
% title('Strains');
% xlim([0 lengthM]);

%%Filter
cutoff = 50;
slice = 26;
scale = slice:1:slice;
[strainFilteteredButter] = filterStrain(strain, mps, cutoff);

% figure(2);
% plot(strainFilteteredButter);
% title('Butter');
% legend('Midt','Hyre');



[strainFilteteredWave, waveletPlot] = wavelet(strain,scale,slice);

% figure(2);
% surf(waveletPlot(:,:,1,1));
% title('Wavelet');
% set(surf(wavelet(:,:,1,1)),'LineStyle','none');
% axis([0 size(wavelet,2) scale(1) scale(end)]);

% figure(1);
% plot(strainFilteteredWave(:,1));
% title(['Strain Filtered by Wavelet for slice ' num2str(slice)]);

%%Axel Spacing
axelSpacingTrue = axelSpacing(strainFilteteredWave, 1, mps, v);

axelDifference(teller,:) = round((axelSpacingTrue-axelSpacing1)*1000);
axelDifferencePercent(teller,:) = round(axelSpacingTrue./axelSpacing1*100-100,1);
axelDifferenceTotalt(teller,:) = sum(axelDifference(teller,:));
axelDifferenceTotaltPercent(teller,:) = (axelDifferenceTotalt(teller)/1000)/sum(axelSpacing1);
axelSpacingTrue2(teller,:) = axelSpacingTrue;
end

cta = sum(abs(axelDifference),2);
[cta, rank] = sort(cta);
cta(isnan(cta)) = [];
ctamean = mean(cta);
ninefive = [ cta(ceil(length(cta)*0.025)), cta(floor(length(cta)*0.975)) ];

axelDifference = axelDifference(rank,:);
axelDifference(isnan(axelDifference(:,1)),:) = [];
axelMeanDifference = mean(axelDifference);
axelLengthTot = mean(sum(axelDifference,2));
axelMeanPercent = nanmean(axelDifferencePercent);

axelSpacingTrue3 = nanmean(axelSpacingTrue2);

axeldifferenceSorted = sort(axelDifference);

results= [axelSpacing1*1000;...
    round(axelMeanDifference);...
    round(axelMeanPercent,1);...
    round(axelLengthTot), zeros(1,6);...
    round(ctamean), zeros(1,6);...
    ninefive, zeros(1,5);...
    axeldifferenceSorted(ceil(size(axeldifferenceSorted,1)*0.025),:);...
    axeldifferenceSorted(floor(size(axeldifferenceSorted,1)*0.975),:);...
    round(((max(abs(axeldifferenceSorted(ceil(size(axeldifferenceSorted,1)*0.025),:)), axeldifferenceSorted(ceil(size(axeldifferenceSorted,1)*0.975),:)))./(axelSpacing1*1000))*100,1)];

clc;
format shortG
disp(results);
histogram(axelDifference(:,1),'normalization','probability','binwidth',5)