format longG
close all; clear; clc; clf;

%%Axels
axelSpacing1=[ 2.500 14.000 2.500 5.125 2.550 13.975 2.500 ];%Axel Spacing (m)
axWeights=[ 83 83 83 83 142 142 142 142 ];

%%Bridge
L=30;                                                 %Lenght of bridge (m)
%%speed
v=20;                                                    %train speed (m/s)
%%Sensors
S=1;                                                   %Sensor Distance (m)
mps=1024;                                     %measurements per second (Hz)

%%InfluenceLine
I = load('IL20.txt');
I = [I(:,1)]*6;

axelSpacing1 = flip(axelSpacing1);
axWeights = flip(axWeights);
I = flip(I);

%%InfluenceOrdinatesMatrix
lengthM = 5000;
M = influenceOrdinatesMatrix(I, v, mps, lengthM, axelSpacing1, 200);

teller=0;
for k=1:100
teller=1+teller
%%Strains
strain = zeros(size(M,1),size(M,4));
    for i=1:size(I,2)
        strain(:,i) = M(:,:,1,i)*transpose(axWeights);
%         strain(:,i) = strain(:,i)+2*(rand(size(strain(:,i)))-0.5)*5e-7;
        strain(:,i)=awgn(strain(:,i), 22, 'measured');
        strain(:,i)=strain(:,i)+transpose(sin(2*pi*10*(1:lengthM)))*5e-7;

    end

% figure(1);
% subplot(2,2,1);
% plot(strain);
% title('Strains');
% legend('Midt','Venstre','Hyre');
% xlim([0 lengthM]);

%%Filter
cutoff = 50;
scale = 15:1:50;

% [strainFilteteredButter] = filterStrain(strain, mps, cutoff);

% figure(2);
% plot(strainFilteteredButter(:,2:3));
% title('Butter');
% legend('Midt','Hyre');


j=0;
for i=scale
j=1+j;
[strainFilteteredWave, waveletPlot] = wavelet(strain,scale,i);

% figure(2);
% surf(waveletPlot(:,:,1,1));
% title('Wavelet');
% set(surf(wavelet(:,:,1,1)),'LineStyle','none');
% axis([0 size(wavelet,2) scale(1) scale(end)]);

% figure(1);
% plot(strainFilteteredWave(:,1));
% title(['Strain Filtered by Wavelet for slice ' num2str(i)]);

%%Axel Spacing
axelSpacingTrue = axelSpacing(strainFilteteredWave, 1, mps, v);

axelDifference(j,:) = round((axelSpacingTrue-axelSpacing1)*1000);
axelDifferencePercent(j,:) = round(axelSpacingTrue./axelSpacing1*100-100,1);
axelDifferenceTotalt(j,:) = sum(axelDifference(j,:));
axelDifferenceTotaltPercent(j,:) = round(axelDifferenceTotalt(j,1)/sum(axelSpacing1),1);
closestonall(j,:) = sum(abs(axelDifference(j,:)));
end
cta(:,k) = closestonall;
end
for r=1:size(cta,1)
bestslicematrix(r,1) = mean(cta(r,:));
end
[~, bsmid] = sort(bestslicematrix);
% [~, bestslice] = min(bestslicematrix,4);
slice = scale(bsmid(1:5))
figure();
set(gcf, 'position',[100 100 780 440])
plot(scale,cta(:,:));
xlabel('Skala')
ylabel('Totalavvik (mm)')
