function [AxDi] = axelSpacing(strain, strainNumber, mps, v)
%     y = diff(strain(:,strainNumber),1); % use this for haar wavelet
    y = strain(:,strainNumber);
    filtervalue = max(y)/4;
    mindistance = (1.5 * mps) / v;
    [pk,locs] = findpeaks(y(:,1),'MinPeakDistance',mindistance,'MinPeakHeight',filtervalue);
    
%     figure();
%     plot(1:size(y,1),y,locs,pk,'v');
%     set(gcf, 'position',[676 361 780 440]);
%     xlabel('Tid (1024 per sekund)')
%     ylabel('Wavelet koeffisient, skala 28')
%     ylim(max(abs(y))*[-1.05 1.05])
    
    AxDi=zeros(1,length(locs)-1);
        for i=1:length(locs)-1
            AxDi(i)=(locs(i+1)-locs(i))*v/mps;
        end
    AxDi = round(AxDi,3);
    if length(AxDi) ~= 7
        AxDi = [ NaN NaN NaN NaN NaN NaN NaN ];
    end
end